#!/bin/sh

#etalon prefix
EP="etalon"

#test prefix
TP="test"

#result prefix
RP="result"

PASSED=0
FAILED=0

echo "Testing WISCK"
echo "1) Standart tests"

for CT in $TP*
do
    CE=`echo $CT | sed "s/$TP/$EP/"`
    CR=`echo $CT | sed "s/$TP/$RP/"`
    wisck < $CT > $CR
    ERR=`cmp $CR $CE`
    if [ -z $ERR ] 
    then
        echo "Test $CT passed";
        PASSED=`expr $PASSED + 1`
    else
        echo "Test $CT failed: $ERR";
        FAILED=`expr $FAILED + 1`
    fi
done


echo "2) Big file test"
echo "preparing big file.."

MULT=128
i=0
while [ $i -lt $MULT ]
do
    cat test3 >> test.big
    cat etalon3.chunk >> etalon.big
    if [ $? -gt 0 ]
    then
        echo "Not enought free space on device. Decrease MULT or specify another dir for big files"
        rm -rf test.big etalon.big
        exit 1
    fi
    i=`expr $i + 1`
done

wisck -LOR < test.big > result.big
ERR=`cmp etalon.big result.big`
if [ -z $ERR ]
then
    echo "Test test.big passed"
    PASSED=`expr $PASSED + 1`
else
    echo "Test test.big failed: $ERR"
    FAILED=`expr $FAILED + 1`
fi

echo "PASSED: $PASSED"
echo "FAILED: $FAILED"

echo "Clearing tmp files.."
rm -rfv result* test.big etalon.big

if [ $FAILED -eq 0 ]
then
    exit 0
else
    exit 1
fi

